﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Telerik.Windows.Controls.Docking;
using System.Windows;
using Telerik.Windows.Controls;

namespace ToolWindowsWithIconsIntoTheTaskBar
{
	public class CustomWindow : ToolWindow
	{
		private Window window;
		private string header;

		public CustomWindow()
		{
			this.Loaded += this.OnToolWindowLoaded;
		}

		private void OnToolWindowLoaded(object sender, System.Windows.RoutedEventArgs e)
		{
			this.window = this.ParentOfType<Window>();
			if (window != null)
			{
				this.window.ShowInTaskbar = true;
				this.window.StateChanged += new EventHandler(window_StateChanged);
				this.IsVisibleChanged += new DependencyPropertyChangedEventHandler(CustomWindow_IsVisibleChanged);

				if (this.header != null)
				{
					this.window.Title = this.header;
					this.Header = this.header;
				}
			}
		}

		protected override void OnHeaderChanged(object oldHeader, object newHeader)
		{
			base.OnHeaderChanged(oldHeader, newHeader);

			if (newHeader != null)
			{
				this.header = newHeader.ToString();
			}

			if (this.window != null)
			{
				this.window.Title = this.header;
				this.Header = this.header;
			}
		}

		void CustomWindow_IsVisibleChanged(object sender, DependencyPropertyChangedEventArgs e)
		{
			this.window.StateChanged -= new EventHandler(window_StateChanged);
			this.IsVisibleChanged -= new DependencyPropertyChangedEventHandler(CustomWindow_IsVisibleChanged);
		}

		void window_StateChanged(object sender, EventArgs e)
		{
			this.WindowState = window.WindowState;
		}
	}
}
